	irqa = $07
	irqx = $08
	irqy = $09
	chbase = $d409
	wsync = $d40a

;2000: lms 2023 mode 4
;2003: mode 4
;2004: mode 4
;2005: dli mode 4
;2006: dli mode 4
;2007: dli mode 4
;2008: dli mode 4
;2009: mode 4
;200a: mode 4
;200b: dli mode 4
;200c: mode 4
;200d: mode 4
;200e: mode 4
;200f: mode 4
;2010: mode 4
;2011: dli mode 4
;2012: mode 4
;2013: mode 4
;2014: mode 4
;2015: mode 4
;2016: mode 4
;2017: mode 4
;2018: mode 4
;2019: dli mode 4
;201a: dli mode 4
;201b: mode 4
;201c: dli mode 4
;201d: dli mode 4
;201e: dli mode 4
;201f: mode 4
;2020: jvb 2000


	org $5000

	lda #$48              ; 2cyc ; a9 48
	sta $d407 ;pmbase     ; 4cyc ; 8d 07 d4
	lda #$03              ; 2cyc ; a9 03
	sta $d01d ;gractl     ; 4cyc ; 8d 1d d0
	lda $14 ;rtclok+2     ; 3cyc ; a5 14
j500c    cmp $14 ;rtclok+2     ; 3cyc ; c5 14
	beq j500c             ; 2cyc ; f0 fc
	sei                   ; 2cyc ; 78
	lda #$00              ; 2cyc ; a9 00
	sta $d40e ;nmien      ; 4cyc ; 8d 0e d4
	sta $d400 ;dmactl     ; 4cyc ; 8d 00 d4
	lda #$fe              ; 2cyc ; a9 fe
	sta $d301 ;portb      ; 4cyc ; 8d 01 d3
	lda #<nmi5633              ; 2cyc ; a9 33
	sta $fffa             ; 4cyc ; 8d fa ff
	lda #>nmi5633             ; 2cyc ; a9 56
	sta $fffb             ; 4cyc ; 8d fb ff
	lda #$c0              ; 2cyc ; a9 c0
	sta $d40e ;nmien      ; 4cyc ; 8d 0e d4
j502d    lda $d010 ;trig0      ; 4cyc ; ad 10 d0
	beq j5045             ; 2cyc ; f0 13
	lda $d011 ;trig1      ; 4cyc ; ad 11 d0
	beq j5045             ; 2cyc ; f0 0e
	lda $d01f ;consol     ; 4cyc ; ad 1f d0
	and #$01              ; 2cyc ; 29 01
	beq j5045             ; 2cyc ; f0 07
	lda $d20f ;skstat     ; 4cyc ; ad 0f d2
	and #$04              ; 2cyc ; 29 04
	bne j502d             ; 2cyc ; d0 e8
j5045    lda #$00              ; 2cyc ; a9 00
	sta $d01d ;gractl     ; 4cyc ; 8d 1d d0
	tax                   ; 2cyc ; aa
j504b    sta $d000,x ;hposp0   ; 5cyc ; 9d 00 d0
	inx                   ; 2cyc ; e8
	bne j504b             ; 2cyc ; d0 fa
	lda #$ff              ; 2cyc ; a9 ff
	sta $d301 ;portb      ; 4cyc ; 8d 01 d3
	lda #$40              ; 2cyc ; a9 40
	sta $d40e ;nmien      ; 4cyc ; 8d 0e d4
	cli                   ; 2cyc ; 58
	rts                   ; 6cyc ; 60

r505d	sta irqa
	sta wsync
	sta wsync
	sta wsync
	sta wsync
	sta wsync
	lda #$1e              ; 2cyc ; a9 1e
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #<r507e              ; 2cyc ; a9 7e
	sta dliv
	lda irqa
	rti                   ; 6cyc ; 40

r507e	sta irqa
	stx irqx
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	sta wsync
	sta wsync
	sta wsync
	sta wsync
	lda #$01              ; 2cyc ; a9 01
	ldx #$77              ; 2cyc ; a2 77
	sta wsync
	sta $d00b ;sizep3     ; 4cyc ; 8d 0b d0
	stx $d003 ;hposp3     ; 4cyc ; 8e 03 d0
	lda #<r50ad              ; 2cyc ; a9 ad
	sta dliv
	lda irqa
	ldx irqx
	rti                   ; 6cyc ; 40

r50ad	sta irqa
	sta wsync
	sta wsync
	sta wsync
	sta wsync
	sta wsync
	lda #$5a              ; 2cyc ; a9 5a
	sta wsync
	sta $d004 ;hposm0     ; 4cyc ; 8d 04 d0
	lda #<r50ce              ; 2cyc ; a9 ce
	sta dliv
	lda irqa
	rti

r50ce	sta irqa
	stx irqx
	lda #$2c              ;chbase
	sta wsync
	sta chbase
	sta wsync
	sta wsync
	sta wsync
	lda #$0c              ; 2cyc ; a9 0c
	ldx #$12              ; 2cyc ; a2 12
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	sta wsync
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$f2              ; 2cyc ; a9 f2
	ldx #$1a              ; 2cyc ; a2 1a
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	stx $d012 ;colpm0     ; 4cyc ; 8e 12 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	sta wsync
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$12              ; 2cyc ; a9 12
	ldx #$71              ; 2cyc ; a2 71
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	stx $d003 ;hposp3     ; 4cyc ; 8e 03 d0
	sta wsync
	sta wsync
	lda #$7a              ; 2cyc ; a9 7a
	sta wsync
	sta $d014 ;colpm2     ; 4cyc ; 8d 14 d0
	lda #<r515d              ; 2cyc ; a9 5d
	sta dliv
	lda #>r515d        ; 2cyc ; a9 51
	sta dliv+1
	lda irqa
	ldx irqx
	rti                   ; 6cyc ; 40

r515d	sta irqa
	stx irqx
	sty irqy
	sta wsync
	sta wsync
	lda #$66              ; 2cyc ; a9 66
	sta wsync
	sta $d004 ;hposm0     ; 4cyc ; 8d 04 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$03              ; 2cyc ; a2 03
	ldy #$81              ; 2cyc ; a0 81
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d009 ;sizep1     ; 4cyc ; 8e 09 d0
	sty $d001 ;hposp1     ; 4cyc ; 8c 01 d0
	lda #$0e              ; 2cyc ; a9 0e
	sta $d013 ;colpm1     ; 4cyc ; 8d 13 d0
	lda #$0c              ; 2cyc ; a9 0c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	sta wsync
	sta wsync
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$30              ;chbase
	ldx #$0c              ; 2cyc ; a2 0c
	sta wsync
	sta chbase
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	sta wsync
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$0c              ; 2cyc ; a9 0c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$0c              ; 2cyc ; a9 0c
	ldx #$22              ; 2cyc ; a2 22
	ldy #$6c              ; 2cyc ; a0 6c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	sty $d003 ;hposp3     ; 4cyc ; 8c 03 d0
	lda #$18              ; 2cyc ; a9 18
	sta $d015 ;colpm3     ; 4cyc ; 8d 15 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$12              ; 2cyc ; a2 12
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	sta wsync
	lda #$0c              ; 2cyc ; a9 0c
	ldx #$22              ; 2cyc ; a2 22
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$12              ; 2cyc ; a2 12
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$22              ; 2cyc ; a9 22
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$0c              ; 2cyc ; a9 0c
	ldx #$22              ; 2cyc ; a2 22
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$22              ; 2cyc ; a9 22
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$16              ; 2cyc ; a9 16
	sta wsync
	sta $d015 ;colpm3     ; 4cyc ; 8d 15 d0
	sta wsync
	sta wsync
	sta wsync
	lda #$2a              ; 2cyc ; a9 2a
	ldx #$18              ; 2cyc ; a2 18
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d015 ;colpm3     ; 4cyc ; 8e 15 d0
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	sta wsync
	lda #$0c              ; 2cyc ; a9 0c
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$2a              ; 2cyc ; a2 2a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$0c              ; 2cyc ; a9 0c
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$2a              ; 2cyc ; a2 2a
	ldy #$7a              ; 2cyc ; a0 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	sty $d003 ;hposp3     ; 4cyc ; 8c 03 d0
	sty $d015 ;colpm3     ; 4cyc ; 8c 15 d0
	lda #$0c              ; 2cyc ; a9 0c
	ldx #$1c              ; 2cyc ; a2 1c
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$2a              ; 2cyc ; a2 2a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$03              ; 2cyc ; a9 03
	ldx #$61              ; 2cyc ; a2 61
	ldy #$0e              ; 2cyc ; a0 0e
	sta wsync
	sta $d00a ;sizep2     ; 4cyc ; 8d 0a d0
	stx $d002 ;hposp2     ; 4cyc ; 8e 02 d0
	sty $d014 ;colpm2     ; 4cyc ; 8c 14 d0
	lda #$0c              ; 2cyc ; a9 0c
	ldx #$1c              ; 2cyc ; a2 1c
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$34              ; chbase
	ldx #$2a
	sta wsync
	sta chbase
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d012 ;colpm0     ; 4cyc ; 8d 12 d0
	sta wsync
	lda #$1c              ; 2cyc ; a9 1c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #<r5311              ; 2cyc ; a9 11
	sta dliv
	lda #>r5311              ; 2cyc ; a9 53
	sta dliv+1
	lda irqa
	ldx irqx
	ldy irqy
	rti                   ; 6cyc ; 40

r5311	sta irqa
	stx irqx
	sty irqy
	sta wsync
	lda #$03              ; 2cyc ; a9 03
	ldx #$a4              ; 2cyc ; a2 a4
	ldy #$20              ; 2cyc ; a0 20
	sta wsync
	sta $d00b ;sizep3     ; 4cyc ; 8d 0b d0
	stx $d003 ;hposp3     ; 4cyc ; 8e 03 d0
	sty $d015 ;colpm3     ; 4cyc ; 8c 15 d0
	sta wsync
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	sta wsync
	lda #$5a              ; 2cyc ; a9 5a
	sta wsync
	sta $d004 ;hposm0     ; 4cyc ; 8d 04 d0
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	sta wsync
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$28              ; 2cyc ; a9 28
	ldx #$66              ; 2cyc ; a2 66
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d004 ;hposm0     ; 4cyc ; 8e 04 d0
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$01              ; 2cyc ; a2 01
	ldy #$7a              ; 2cyc ; a0 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d00b ;sizep3     ; 4cyc ; 8e 0b d0
	sty $d003 ;hposp3     ; 4cyc ; 8c 03 d0
	sty $d015 ;colpm3     ; 4cyc ; 8c 15 d0
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$38              ; chbase
	ldx #$2a              ; 2cyc ; a2 2a
	sta wsync
	sta chbase
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$12              ; 2cyc ; a2 12
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$22              ; 2cyc ; a2 22
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$2a              ; 2cyc ; a9 2a
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$28              ; 2cyc ; a2 28
	ldy #$12              ; 2cyc ; a0 12
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	sty $d019 ;colpf3     ; 4cyc ; 8c 19 d0
	lda #$22              ; 2cyc ; a9 22
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$12              ; 2cyc ; a2 12
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$22              ; 2cyc ; a2 22
	ldy #$00              ; 2cyc ; a0 00
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	sty $d00b ;sizep3     ; 4cyc ; 8c 0b d0
	lda #$82              ; 2cyc ; a9 82
	sta $d003 ;hposp3     ; 4cyc ; 8d 03 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	sta wsync
	lda #$22              ; 2cyc ; a9 22
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$1a              ; 2cyc ; a9 1a
	ldx #$12              ; 2cyc ; a2 12
	ldy #$00              ; 2cyc ; a0 00
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d019 ;colpf3     ; 4cyc ; 8e 19 d0
	sty $d009 ;sizep1     ; 4cyc ; 8c 09 d0
	lda #$59              ; 2cyc ; a9 59
	sta $d001 ;hposp1     ; 4cyc ; 8d 01 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$26              ; 2cyc ; a2 26
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$1a              ; 2cyc ; a9 1a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$26              ; 2cyc ; a2 26
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$1a              ; 2cyc ; a9 1a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$28              ; 2cyc ; a2 28
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$1a              ; 2cyc ; a9 1a
	ldx #$26              ; 2cyc ; a2 26
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$1c              ; 2cyc ; a9 1c
	ldx #$26              ; 2cyc ; a2 26
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$1a              ; 2cyc ; a9 1a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$28              ; 2cyc ; a9 28
	ldx #$5c              ; 2cyc ; a2 5c
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	stx $d004 ;hposm0     ; 4cyc ; 8e 04 d0
	lda #$3c              ; chbase
	ldx #$26              ; 2cyc ; a2 26
	sta wsync
	sta chbase
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	sta wsync
	sta wsync
	lda #$28              ; 2cyc ; a9 28
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$26              ; 2cyc ; a9 26
	sta wsync
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	sta wsync
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	sta wsync
	lda #$f2              ; 2cyc ; a9 f2
	ldx #$64              ; 2cyc ; a2 64
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	stx $d004 ;hposm0     ; 4cyc ; 8e 04 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$1e              ; 2cyc ; a9 1e
	ldx #$2a              ; 2cyc ; a2 2a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d018 ;colpf2     ; 4cyc ; 8e 18 d0
	lda #$12              ; 2cyc ; a9 12
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$f2              ; 2cyc ; a9 f2
	sta wsync
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #<r5548              ; 2cyc ; a9 48
	sta dliv
	lda #>r5548              ; 2cyc ; a9 55
	sta dliv+1
	lda irqa
	ldx irqx
	ldy irqy
	rti

r5548	sta irqa
	lda #$40              ; chbase
	sta wsync
	sta chbase
	lda #$0a              ; 2cyc ; a9 0a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #<r5562              ; 2cyc ; a9 62
	sta dliv
	lda irqa
	rti                   ; 6cyc ; 40

r5562	sta irqa
	stx irqx
	lda #$34              ; chbase
	sta wsync
	sta chbase
	sta wsync
	lda #$7a              ; 2cyc ; a9 7a
	ldx #$5c              ; 2cyc ; a2 5c
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	stx $d004 ;hposm0     ; 4cyc ; 8e 04 d0
	lda #$0a              ; 2cyc ; a9 0a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	sta wsync
	lda #$7a              ; 2cyc ; a9 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$0a              ; 2cyc ; a9 0a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$7a              ; 2cyc ; a9 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$28              ; chbase
	sta wsync
	sta chbase
	sta wsync
	lda #$66              ; 2cyc ; a9 66
	sta wsync
	sta $d004 ;hposm0     ; 4cyc ; 8d 04 d0
	sta wsync
	sta wsync
	lda #$8a              ; 2cyc ; a9 8a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$7a              ; 2cyc ; a9 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #<r55d4              ; 2cyc ; a9 d4
	sta dliv
	lda irqa
	ldx irqx
	rti                   ; 6cyc ; 40

r55d4	sta irqa
	stx irqx
	lda #$2c              ; chbase
	ldx #$8a              ; 2cyc ; a2 8a
	sta wsync
	sta chbase
	stx $d017 ;colpf1     ; 4cyc ; 8e 17 d0
	lda #$7a              ; 2cyc ; a9 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$8a              ; 2cyc ; a9 8a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$7a              ; 2cyc ; a9 7a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$8a              ; 2cyc ; a9 8a
	sta wsync
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #<r5614              ; 2cyc ; a9 14
	sta dliv
	lda #>r5614              ; 2cyc ; a9 56
	sta dliv+1
	lda irqa
	ldx irqx
	rti
	
r5614	sta irqa
	lda #$38              ; chbase
	sta wsync
	sta chbase
	lda #<r5626              ; 2cyc ; a9 26
	sta dliv
	lda irqa
	rti                   ; 6cyc ; 40

r5626	sta irqa
	lda #$28              ;chbase
	sta wsync
	sta chbase
	lda irqa
	rti                   ; 6cyc ; 40

nmi5633	bit $d40f ;nmist
	bpl l563b
dliv	= *+1
	jmp r505d

l563b	sta irqa
	stx irqx
	sty irqy
	sta $d40f ;nmires     ; 4cyc ; 8d 0f d4
	lda #$00              ; 2cyc ; a9 00
	sta $d402 ;dlistl     ; 4cyc ; 8d 02 d4
	lda #$20              ; 2cyc ; a9 20
	sta $d403 ;dlisth     ; 4cyc ; 8d 03 d4
	lda #$3e              ; 2cyc ; a9 3e
	sta $d400 ;dmactl     ; 4cyc ; 8d 00 d4
	inc $06 ;tramsz       ; 5cyc ; e6 06
	lda #$28              ; chbase,vbi
	sta chbase
	lda #$00              ; 2cyc ; a9 00
	sta $d01a ;colbk      ; 4cyc ; 8d 1a d0
	lda #$06              ; 2cyc ; a9 06
	sta $d016 ;colpf0     ; 4cyc ; 8d 16 d0
	lda #$8c              ; 2cyc ; a9 8c
	sta $d017 ;colpf1     ; 4cyc ; 8d 17 d0
	lda #$76              ; 2cyc ; a9 76
	sta $d018 ;colpf2     ; 4cyc ; 8d 18 d0
	lda #$f2              ; 2cyc ; a9 f2
	sta $d019 ;colpf3     ; 4cyc ; 8d 19 d0
	lda #$04              ; 2cyc ; a9 04
	sta $d01b ;prior      ; 4cyc ; 8d 1b d0
	lda #$01              ; 2cyc ; a9 01
	sta $d008 ;sizep0     ; 4cyc ; 8d 08 d0
	lda #$59              ; 2cyc ; a9 59
	sta $d000 ;hposp0     ; 4cyc ; 8d 00 d0
	lda #$1c              ; 2cyc ; a9 1c
	sta $d012 ;colpm0     ; 4cyc ; 8d 12 d0
	lda #$00              ; 2cyc ; a9 00
	sta $d00b ;sizep3     ; 4cyc ; 8d 0b d0
	lda #$7f              ; 2cyc ; a9 7f
	sta $d003 ;hposp3     ; 4cyc ; 8d 03 d0
	lda #$0e              ; 2cyc ; a9 0e
	sta $d015 ;colpm3     ; 4cyc ; 8d 15 d0
	lda #$67              ; 2cyc ; a9 67
	sta $d004 ;hposm0     ; 4cyc ; 8d 04 d0
	lda #$00              ; 2cyc ; a9 00
	sta $d009 ;sizep1     ; 4cyc ; 8d 09 d0
	lda #$54              ; 2cyc ; a9 54
	sta $d001 ;hposp1     ; 4cyc ; 8d 01 d0
	lda #$12              ; 2cyc ; a9 12
	sta $d013 ;colpm1     ; 4cyc ; 8d 13 d0
	lda #$01              ; 2cyc ; a9 01
	sta $d00a ;sizep2     ; 4cyc ; 8d 0a d0
	lda #$78              ; 2cyc ; a9 78
	sta $d002 ;hposp2     ; 4cyc ; 8d 02 d0
	lda #$22              ; 2cyc ; a9 22
	sta $d014 ;colpm2     ; 4cyc ; 8d 14 d0
	lda #$00              ; 2cyc ; a9 00
	sta $d00c ;sizem      ; 4cyc ; 8d 0c d0
	lda #$96              ; 2cyc ; a9 96
	sta $d007 ;hposm3     ; 4cyc ; 8d 07 d0
	lda #$95              ; 2cyc ; a9 95
	sta $d006 ;hposm2     ; 4cyc ; 8d 06 d0
	lda #$00              ; 2cyc ; a9 00
	sta $d005 ;hposm1     ; 4cyc ; 8d 05 d0
	lda #<r505d             ; 2cyc ; a9 5d
	sta dliv
	lda #>r505d              ; 2cyc ; a9 50
	sta dliv+1
	lda irqa
	ldx irqx
	ldy irqy
	rti                   ; 6cyc ; 40
