;	Extracts and remaps the fonts from uncompresse G2F which was created based in the MIC file. 
;
;	Run in Atari800 Win
;	Enter debugger
;	write 2000 47ff C:\jac\system\Atari800\Programming\Demos\SillyPack2k12\atr\fix\GFX\Flame\ExtractFonts.chr

	org $2000
	
	.local fonts
	ins "Flame-Final-uncompressed.g2f",+3+1200,10*$400
	.endl

p1	= $80
x1	= $e0
x2	= $e1

start	mwa #fonts p1

loop	ldy #0
	lda (p1),y
	jsr remap
	sta (p1),y
	inc p1
	bne no_hi
	inc p1+1
no_hi	lda p1+1
	cmp #>[fonts+.len fonts]
	bne loop
	.byte 2

	.proc remap

	sta x1
	lda #0
	sta x2
	jsr remap_pixel
	ora x2
	sta x2


	jsr remap_pixel
	asl
	asl
	ora x2
	sta x2

	jsr remap_pixel
	asl
	asl
	asl
	asl
	ora x2
	sta x2

	jsr remap_pixel
	asl
	asl
	asl
	asl
	asl
	asl
	ora x2
	sta x2

	lda x2
	rts

	.proc remap_pixel
	lda x1
	lsr x1
	lsr x1
	and #3
	tax
	lda tab,x
	rts
	
tab	 .byte 0,3,1,2
	.endp

	.endp

	run start